// derJamminIndieGameenHausen - Irrascible God Bowling

// general configuration

// Tech
//    How do i bounce off buildings?
//
// Game, probably
//    better ball physics - spin in air, figure out slope bug
//    many scoring and so on tweaks
//    find edge of map

#define GAME_SOUNDS
//#define POWER_BAR

// to do
//  - dont suck
//  - show score better, prorate high-score fields correctly
//  - add "energy meter" to give you reason to time - power/golf etc...
//  - ball slows down as it hits guys...
//  - FLOCKING
//  - better guys being tossed up off of it...
//  - smaller radius for flee
//  - real timesteps
//  - more speed range, slow down during flee
//  - more randomness during flee action
//  - dont suck

// ok, that power bar sucks
// new power bar should be
//  - hold down fire key
//  - while down, ball power meter drops
//  - when you let go, it fires
// or, maybe, no power meter at all...

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>

#include <math.h>

// engine stuff
#include "globals.h"
#include "sound/sound_public.h"
#include "sprite_texture.h"
#include "memory_utils.h"
#include "value_map.h"
#include "system.h"

#include "camera.h"
#include "app_camera.h"

#include "font.h"

#include "math3d.h"

// game stuff
#include "guys.h"
#include "hf.h"
#include "buildings.h"
#include "animation.h"
#include "animation_public.h"

#include "sound/ds.h" // @todo take this out when debugging is done
#include "sound/sound_manager.h" // @todo take this out when debugging is done

// allocated guy game_data bytes
#define TYPE(g)  (*(uint8*)((g)->game_data+0))  // 0   uint8

void AngryRender(void);
void AngryTick(float time, float dt);
int  AngryChar(int charcode);
void AngryInit(void);

#if 0   // change this to 1 to enable (make sure you change game.cpp as well)
// define system hooks and hook ourselves in
system_hooks SystemHooks = {
    AngryInit,
    AngryRender,
    AngryTick,
    AngryChar,
};
#endif

static float hf_old[HF_Y][HF_X];

Animation_Texture_Set *prophet_texture_set;
Animation_Mode *prophet_mode;

#define RANDGUYS 1
#if RANDGUYS
// these all don't fit in the currently-small texture, sadly
struct rand_guys
{
    char *name;
    char anim;
    int frames;
    Animation_Texture_Set *set;
    Animation_Mode *mode;
} RandGuys[] =
{
    { "sprites/atc2sf/sprites/sarg", 'a', 4 },
    { "sprites/atc2sf/sprites/skul", 'a', 4 },
    { "sprites/batman/sprites/bos2", 'a', 4 },
    { "sprites/batman/sprites/boss", 'a', 4 },
    { "sprites/batman/sprites/bspi", 'a', 4 },
    { "sprites/batman/sprites/cybr", 'a', 4 },
    { "sprites/batman/sprites/fatt", 'a', 4 },
    { "sprites/batman/sprites/play", 'a', 4 },
    { "sprites/batman/sprites/sarg", 'a', 4 },
    { "sprites/batman/sprites/skel", 'a', 4 },
    { "sprites/batman/sprites/spid", 'a', 4 },
    { "sprites/batman/sprites/spos", 'a', 4 },
    { "sprites/doom2/sprites/cybr", 'a', 4 },
    { "sprites/doom2/sprites/fatt", 'a', 6 },
    { "sprites/doom2/sprites/poss", 'a', 4 },
#if 0
    { "sprites/doom2/sprites/skel", 'a', 4 },
    { "sprites/doom2/sprites/bos2", 'a', 4 },
    { "sprites/doom2/sprites/bspi", 'a', 6 },
    { "sprites/doom2/sprites/cpos", 'a', 4 },
    { "sprites/doom95/sprites/play", 'a', 4 },
    { "sprites/doom95/sprites/boss", 'a', 4 },
    { "sprites/doom95/sprites/troo", 'a', 4 },
#endif
    { "sprites/fistful/sprites/cpos", 'a', 4 },
    { "sprites/fistful/sprites/play", 'a', 4 },
    { "sprites/fistful/sprites/poss", 'a', 4 },
    { "sprites/fistful/sprites/sarg", 'a', 4 },
    { "sprites/fistful/sprites/spos", 'a', 4 },
    { "sprites/gold64/sprites/cpos", 'a', 4 },
    { "sprites/gold64/sprites/fatt", 'a', 4 },
    { "sprites/gold64/sprites/sarg", 'a', 4 },
#if 0
    { "sprites/helltest/sprites/bspi", 'a', 4 },
    { "sprites/helltest/sprites/cpos", 'a', 4 },
    { "sprites/helltest/sprites/head", 'a', 4 },
    { "sprites/helltest/sprites/poss", 'a', 4 },
    { "sprites/helltest/sprites/sarg", 'a', 4 },
    { "sprites/hexen/sprites/cent", 'a', 4 },
#endif
    { "sprites/stardoom/sprites/boss", 'a', 4 },
    { "sprites/stardoom/sprites/poss", 'a', 4 },
};
int const RandGuysCount = (sizeof(RandGuys)/sizeof(RandGuys[0]));
#endif

Animation_Texture_Set *gib_texture_set;
Animation_Mode *gib_mode;

enum GuyModeAI
{
   kaiNone,
   kaiFlee,
   kaiToss1,  // while playing death anim
   kaiToss2,  // after playing death anim
   kaiKill,
   kaiFollowFirst,
   kaiFollowLast=kaiFollowFirst+31,
};

vec3f follow_target[kaiFollowLast+1];

///////////////////////
// context
#define INITIAL_GUYS 25000

font *angryFont=NULL;
GLuint ballDisplayList=0;

#define ROLL_SOUND "sound22"
#define BOWL_SOUND "sound19"
#define KILL_SOUND "sound21"

#define MAX_PICKED 1024
Guy *pickUpList[MAX_PICKED];
int  pickUpIdx=0;

///////////////////////
// scoring
#define SCORE_FILE "//walt/public/igj0/irate_score.txt"
//#define SCORE_FILE "irate_score.txt"
float cur_game_time=0.0f;
int   gBestKills=0;
int   gBallThrows=0;
int   gScoreMode=0;

// game controls
int   gBallLaunching=0;
float gPowerBarMax=0, gPowerBarCur=0, gPowerBarLaunch=0;

///////////////////////
// The Ball Setup

// the balls
#define MAX_BALLS  4
Guy   gBalls[MAX_BALLS];
float gBallsTime[MAX_BALLS];
int   gBallKills[MAX_BALLS];
float gBallSpd[MAX_BALLS];  // hmmm, a struct, perhaps, someday
#define BALL_SPEED    200  // or more?
#define BALL_H        14
#define BALL_V        30
// @todo - for real, have it slow, on zero, explode, end at edge of map
#define BALL_LIFETIME 60.0  // perhaps, really, slow it down, kill on stop?

#define BallActive(gIdx) (gBalls[gIdx].vel.x||gBalls[gIdx].vel.y||gBalls[gIdx].vel.z)

#define BALL_TEXTURE_WIDTH 512
#define BALL_TEXTURE_HEIGHT 256
Sound_Channel *gBallChan[MAX_BALLS];
GLuint gBallTextureHandles[MAX_BALLS];
uint32 *gBallTextures[MAX_BALLS];
bool gBallTextureDirty[MAX_BALLS];
matrix_3x3 gBallOrientation[MAX_BALLS];

sprite_texture *GibTexture = 0;

int gBallPickedup=0;
int gBallPause=0;

// Ball system management
// BallPasteImage pastes an alpha image into the ball texture map wrapping at edges
#define BALLXY(x,y) ((x)%BALL_TEXTURE_WIDTH + ((y)%BALL_TEXTURE_HEIGHT)*BALL_TEXTURE_WIDTH)
void BallPasteImage( int32 SrcX0, int32 SrcY0, int32 SrcX1, int32 SrcY1, int32 SrcStride, uint32 *SrcData,
                     int32 DstX0, int32 DstY0, uint32 *DstData )
{
    for(int sy = SrcY0,dy = DstY0;sy < SrcY1;++sy,++dy)
    {
        for(int sx = SrcX0,dx = DstX0;sx < SrcX1;++sx,++dx)
        {
            uint32 c = SrcData[sx+sy*SrcStride];
            if(c & 0xFF000000)
            {
                DstData[BALLXY(dx,dy)] = c;
            }
        }
    }
}
#undef BALLXY
inline int32 CModSucks( int32 a, int32 b )
{
    assert(b > 0);
    if(a > 0) {
        return a % b;
    } else {
        return b - (-a) % b;
    }
}
void
WetterGib(int32 BallIndex,float xsplat, float ysplat) 
{
    // splat coordinates are center point relative in world space
    gBallTextureDirty[BallIndex] = true;
    
    int width = BALL_TEXTURE_WIDTH;
    int height = BALL_TEXTURE_HEIGHT;
    uint32 *data = gBallTextures[BallIndex];

    sprite_image &Image =
        GibTexture->Animations[0].Frames[
            rand()%GibTexture->Animations[0].FrameCount].Directions[0];

    // find the point on the ball that points to the splat
    vector_3 p = Transpose(gBallOrientation[BallIndex]) *
        vector_3(xsplat/BALL_H,ysplat/BALL_H,-1).Normalize();

    // map to gluSphere lat/long texcoords

    // s = +Y -> 0, -X -> 0.25, -Y -> 0.5, +X -> 0.75
    // rotate +90 degrees (so -pi,pi is +Y ccw), normalize, then make 0,1
    float s = atan2(p(0),-p(1))/(2*RealPi) + 0.5;  

    // t = +Z,-Z -> 1,0 (through a sin)
    float t = asin(p(2))/RealPi + 0.5;

    int x = int(s * width)%width, y = int(t * height)%height;

    // blt the center of the image to the center of the texture point
    int32 SrcWidth = Image.XMax - Image.XMin;
    int32 SrcHeight = Image.YMax - Image.YMin;
    BallPasteImage(Image.XMin, Image.YMin,
                   Image.XMax, Image.YMax,
                   GibTexture->TextureDimension,(uint32 *)GibTexture->Pixels,
                   CModSucks(x-SrcWidth/2,BALL_TEXTURE_WIDTH),
                   CModSucks(y-SrcHeight/2,BALL_TEXTURE_HEIGHT),data);
}

void
BindBallTexture(int32 BallIndex)
{    
    glBindTexture(GL_TEXTURE_2D, gBallTextureHandles[BallIndex]);
    if(gBallTextureDirty[BallIndex])
    {
        int width = BALL_TEXTURE_WIDTH;
        int height = BALL_TEXTURE_HEIGHT;
        uint32 *data = gBallTextures[BallIndex];
        glTexImage2D(GL_TEXTURE_2D, 0,
                     4, width, height, 0,
                     GL_BGRA_EXT, GL_UNSIGNED_BYTE, data);

        gBallTextureDirty[BallIndex] = false;
    }
}

int GetAvailableBall(void)
{
   for (int i=0; i<MAX_BALLS; i++)
      if (!(BallActive(i)))
         return i;
   return -1;
}

int FindOldestBall(void)
{
   int oldest=-1;
   for (int i=0; i<MAX_BALLS; i++)
      if (BallActive(i))
         if ((oldest==-1)||(gBallsTime[i]<gBallsTime[oldest]))
            oldest=i;
   return oldest;
}

void BallDeactivate(int gIdx)
{
   gBalls[gIdx].vel.x=gBalls[gIdx].vel.y=gBalls[gIdx].vel.z=0;
   if (gBallKills[gIdx]>gBestKills)
      gBestKills=gBallKills[gIdx];
   gBallKills[gIdx]=0;

#ifdef GAME_SOUNDS
         sound_channel_release(gBallChan[gIdx]);
#endif
}

// calls for the app
int BallCreate(void)
{
   int ballId=GetAvailableBall();
   if (ballId==-1)
   {
      ballId=FindOldestBall();
      if (gBallChan[ballId])
      {
#ifdef GAME_SOUNDS
         sound_channel_release(gBallChan[ballId]);
#endif
         gBallChan[ballId]=NULL;
      }
      BallDeactivate(ballId);
   }
   if (ballId!=-1)
   {
#ifdef USE_POWER_BAR
      gBallSpd[ballId]=(BALL_SPEED/3)+(BALL_SPEED*gPowerBarLaunch/4);
#else
      gBallSpd[ballId]=(BALL_SPEED*3/5);
#endif
      Guy *pBall=&gBalls[ballId];
      real32 cam_pos[4];
      GetCameraLocation(*GlobalCamera,cam_pos);
      pBall->loc=*((vec3f*)&cam_pos);
      pBall->physics_mode=PM_GRAVITY;
      vec3f_scale(&pBall->vel,(vec3f*)CameraBackward(),-gBallSpd[ballId]);
      gBallsTime[ballId]=BALL_LIFETIME;
      pBall->ai_timer=INT_MAX_TIMER;
#ifdef GAME_SOUNDS
      sound_play(BOWL_SOUND, 1.0f);
      gBallChan[ballId]=sound_channel_create();
//      gBallChan[ballId]=0;
      if (gBallChan[ballId]) {
          // We will actually play some sound into this channel later.
          sound_channel_set_volume(gBallChan[ballId],0.0f);
      }
#endif
      gBallThrows++;
      // clear out the texture
      memset(gBallTextures[ballId],0,BALL_TEXTURE_WIDTH*BALL_TEXTURE_HEIGHT*sizeof(uint32));
      gBallTextureDirty[ballId] = true;
   }
   return ballId==-1?-1:0;
}

///////////////
// Callbacks and Kills
// global for use in callback - really should pass data, but screw it for now
#define MAX_KILL 1024
int gKillList[MAX_KILL];
int gKillCnt=0;

// should probably change to a parm, but oh well
Guy *pCurBall;

Animation_Mode *death_mode, *post_death_mode;

void DudeKillCBack(Guy *g, float d2, void *parm)
{
   // dont reset the state if it is already in progress
   if (g->ai_mode == kaiToss1 || g->ai_mode == kaiToss2)
      return;

   // compute a new velocity that doesnt suck...
   // well, ok, ask Chris to do it...
   g->ai_mode = kaiToss1;

   g->vel.z=64+(64*frandom());
   g->vel.x=-pCurBall->vel.x;   // should map onto normal of velocity, bias by that
   g->vel.y=-pCurBall->vel.y;
   g->vel.x+=6*floatrandneg();
   g->vel.y+=6*floatrandneg();
   g->vel.x/=3;
   g->vel.y/=3;
   g->physics_mode=PM_GRAVITY;
   TYPE(g) = 1;

   aimGuyAlong(g);

   g->ai_timer = animation_dude_set_mode_oneshot(g, death_mode);

   // really, should add a more real BallIdx, eh?
   gBallKills[pCurBall-gBalls]++;
   // @todo need to pass the actual splat coordinates here
   float r = BALL_H * 0.8;
   WetterGib(pCurBall - gBalls,floatrandneg()*r,floatrandneg()*r);
}

#define FLEE_BASE 6

// flee - probably should run less, really
void DudeFleeCBack(Guy *g, float d2, void *parm)
{  
   if (g->ai_mode == kaiToss1 || g->ai_mode == kaiToss2)
      return;

// set the guys velocity away from the flee point, proportional to d2
   vec3f delta;
   vec3f_sub(&delta,&g->loc,&pCurBall->loc);
   delta.z=0;  // for now, in 2d no-flooring land
   vec3f_normeq(&delta);
   float scale = (d2<(BALL_H*BALL_H))?16*FLEE_BASE:(d2<(BALL_H*BALL_H*4))?6*FLEE_BASE:4*FLEE_BASE;  // awwwwww yea
   vec3f_scale(&g->vel,&delta,scale);
   g->ai_timer = 1500;
   setSpeed(g, scale);
   aimGuyAlong(g);
   g->ai_mode = kaiFlee;
   TYPE(g)=2;
}

#define FOLLOW_SPEED 12.0
#define FOLLOW_RADIUS 24

void doDeferredKill(Guy *g)
{
   g->ai_mode = kaiKill;
   if (gKillCnt<MAX_KILL)
      gKillList[gKillCnt++]=g-gGuys;  // find the id
}

void AngryGuyAITimer(Guy *g)
{
   g->ai_timer=0xffff;

   if (g->ai_mode == kaiToss1)
   {
      animation_dude_set_mode(g, post_death_mode);
      g->ai_timer=3000;  // millisecond
      g->ai_mode = kaiToss2;
      return;  // tossed guys are deferred death
   }

   if (g->ai_mode == kaiToss2)
   {
      doDeferredKill(g);
      return;  // tossed guys are deferred death
   }

   if (g->ai_mode == kaiFlee)
   {
      randneg_vec3f(&g->vel);
      g->vel.z=0;
      vec3f_scaleeq(&g->vel,FOLLOW_SPEED);
      setSpeed(g, FOLLOW_SPEED);
      g->ai_mode = kaiNone;
      if (GenerateUnitRandomReal() < 0.80) {
         float best_d = 200*200,d;
         for (int i=kaiFollowFirst; i <= kaiFollowLast; ++i) {
            d = sqr(g->loc.x - follow_target[i].x) + sqr(g->loc.y - follow_target[i].y);
            if (d < best_d) {
               g->ai_mode = i;
               best_d = d;
            }
         }
      }
      if (g->ai_mode == kaiNone) {
         aimGuyAlong(g);
      }
   }

   if (g->ai_mode >= kaiFollowFirst && g->ai_mode <= kaiFollowLast) {
      TYPE(g) = 2;
      g->ai_timer = guyAimNear(g, follow_target[g->ai_mode].x, follow_target[g->ai_mode].y, FOLLOW_RADIUS, FOLLOW_SPEED);
      return;
   }
}

// a guy with gravity hit the ground. return a bounce percentage
float AngryGuyHitTerrain(Guy *g)
{
   if (g->vel.z < -60.0) return 0.8;
   if (g->ai_mode==kaiToss1 || g->ai_mode==kaiToss2)  // he's tossed, kick his ass
      doDeferredKill(g);
   return 0;
}

int cBackKillSort(const void *p1, const void *p2)
{
   int i1=*(int *)p1;
   int i2=*(int *)p2;
   return i1>i2?1:i1==i2?0:-1;
}

void FinishKills(void)
{
   // first, qsort the killist
   // base, num, size, compare
   if (gKillCnt)
   {
      qsort(gKillList,gKillCnt,sizeof(gKillList[0]),cBackKillSort);
      for (; gKillCnt>0; gKillCnt--)
         deleteGuy(gKillList[gKillCnt-1]);
   }
}

bool IsBallRolling( Guy *pCurBall, float *GroundZ )
{
    bool rolling = false;
    float ball_terr_z=ground(pCurBall->loc.x,pCurBall->loc.y);
    if (pCurBall->loc.z<=ball_terr_z+1.0) // -BALL_V/2)
    {
        if(GroundZ)
        {
            *GroundZ = ball_terr_z;
        }
        rolling = true;
    }
    return rolling;
}

///////////////
// Tick

void runGuyHack(Guy *g, int n, int dt)
{
   float cached_dt_float = INT_TIME_TO_FLOAT_TIME(dt);
   float cached_dt_float_2 = cached_dt_float/2;

   while (--n >= 0) {
      float grav = gravity[g->physics_mode];
      float z0 = g->vel.z;
      float dx, dy;
      float orig_h = ground_slope(g->loc.x, g->loc.y, &dx, &dy);

      // @todo: do this right - hack normal based modification in here
      if (g->physics_mode == PM_FLOORED || g->loc.z <= orig_h+0.02)
      {  // adjust velocity here - not sure why it is negative, why i need 0.02 above
         // hmmm, perhaps normalize this
         // float dist = dx*dx + dy*dy;
         g->vel.x -= dx * 100 * cached_dt_float;  // scale?
         g->vel.y -= dy * 100 * cached_dt_float;
      }

      g->vel.z -= grav * cached_dt_float;
      g->loc.x += g->vel.x * cached_dt_float;
      g->loc.y += g->vel.y * cached_dt_float;
      g->loc.z += (g->vel.z+z0) * cached_dt_float_2;
      float h = ground(g->loc.x, g->loc.y);
      if (g->physics_mode == PM_FLOORED)
         g->loc.z = h;
      else if (g->loc.z < h) {
         // for the ball, we dont want the same appGuyHit
         if (g->vel.z<0)
         {
            float r = (g->vel.z < -60.0)?0.42:0;
            g->vel.z = -g->vel.z*r;
         }
         g->loc.z = h;
      }

      // @todo: teach to bounce off top of buildings
      for (int i=0; i < num_buildings; ++i) {
         if (g->loc.x + BALL_H < building[i].x0) continue;
         if (g->loc.x - BALL_H > building[i].x1) continue;
         if (g->loc.y + BALL_H < building[i].y0) continue;
         if (g->loc.y - BALL_H > building[i].y1) continue;
         if (g->loc.z - BALL_H > building[i].h)  continue;

         // where we started the frame
         g->loc.x -= g->vel.x * cached_dt_float;
         g->loc.y -= g->vel.y * cached_dt_float;

         // @WARNING this is really _not_ the right approach
         // i overcomplicated it heavily
         // but it does seem to work, so im gonna fix it later

         // now, how far to each side
         float dxl = building[i].x0 - (g->loc.x + BALL_H);  // left
         float dxr = (g->loc.x - BALL_H) - building[i].x1;  // right
         float dyt = building[i].y0 - (g->loc.y + BALL_H);
         float dyb = (g->loc.y - BALL_H) - building[i].y1;

         int norm_idx=0;
         if (dxl>0) 
            if (dyt>0)
               norm_idx=(dyt>dxl)?0:3;
            else
               norm_idx=(dyb>dxl)?2:3;
         else
            if (dyt>0)
               norm_idx=(dyt>dxr)?0:1;
            else
               norm_idx=(dyb>dxr)?2:1;

         if (norm_idx&1)
            g->vel.x = -g->vel.x;
         else
            g->vel.y = -g->vel.y;

         g->vel.x *= 0.95;
         g->vel.y *= 0.95;

         break;
      }
   }
}

void BallTick(float dt)
{  // move the ball
   static int fleeframe=0;
   static vec3f last_cursor={0,0,0};
   cur_game_time+=dt;

   // more value_map testing
   static value_map *m = MapCreate(256,256,0);
   MapSetPointSample(m,GlobalCamera->Position[0],GlobalCamera->Position[1],255);
//   MapSetTerrainTextureChannels(0,m,0);	// display this value map in the green channel of the terrain texture.

#ifdef POWER_BAR
   switch (gBallLaunching)
   {  // exponentiate this crap, non-linear wack, etc...
      case 0: 
         gPowerBarMax+=dt/2;
         if (gPowerBarMax>1)
            gPowerBarMax=1;
         break;
      case 1:
         gPowerBarCur+=dt/2; 
         if (gPowerBarCur>gPowerBarMax)
            gPowerBarCur=gPowerBarMax;  // really, should auto-kick to next, i think
         break;
      case 2:
         gPowerBarCur-=dt; 
         if (gPowerBarCur>0)   // dont drain sub-zero
            gPowerBarMax-=dt; 
         break;
   }
#endif

   // handle pickup
   if (gBallPickedup)
   {
      vec3f delta;
      vec3f_sub(&delta,&playerCursorPos,&last_cursor);
      for (int j=0; j<pickUpIdx; j++)
         vec3f_add(&pickUpList[j]->loc,&pickUpList[j]->loc,&delta);
   }
   last_cursor=playerCursorPos;

   int i;

   // update the follow targets...the leaders (prophets?) are the
   // first kaiFollowLast guys...make sure they look like it
   for (i=0; i <= kaiFollowLast; ++i) {
      follow_target[i] = gGuys[i].loc;
      TYPE(gGuys+i) = 1;
      gGuys[i].collide_flags &= ~128;  // leaders don't flock

      animation_dude_set_mode(&gGuys[i], prophet_mode);
   }

   ++fleeframe;
   for (i=0; i<MAX_BALLS; i++)
      if (!gBallPause&&BallActive(i))
      {
         int rolling=0;
         pCurBall=&gBalls[i];

         // first, are we too old?
         gBallsTime[i]-=dt;
         if (gBallsTime[i]<0)
         {
            BallDeactivate(i);
            continue;
         }

         if (fabs(pCurBall->vel.x)+fabs(pCurBall->vel.y)+fabs(pCurBall->vel.z)<0.1)
         {
            BallDeactivate(i);
            continue;
         }

         // @todo: reaim?
         int idt=FLOAT_TIME_TO_INT_TIME(dt);
         if (idt==0) idt=1;

         // snap location before
         bool pre_rolling = IsBallRolling(pCurBall,0);
         vec3f loc0 = pCurBall->loc; 

         runGuyHack(pCurBall,1,idt);  // dont do binning

         vec3f loc1 = pCurBall->loc; // snap location after

         if (pre_rolling)
            if (loc1.x<0||loc1.x>WORLD_X||loc1.y<0||loc1.y>WORLD_Y)
            {
               BallDeactivate(i);
               continue;
            }

         float ball_terr_z;
         if(IsBallRolling(pCurBall,&ball_terr_z))
         {
            pCurBall->loc.z=ball_terr_z; // -BALL_V/2;
            rolling=1;
            if(pre_rolling)
            {
                // okay, we rolled this entire frame...theoretically
                // we know Guys travel at constant x,y speed in the plane...ithink
                vector_3 v = vector_3((float*)&loc1) - vector_3((float*)&loc0);
                float vl = v.Length();
                vector_3 axis = CrossProduct(vector_3(0,0,1),v).Normalize();
                float angle = vl/BALL_H;
                if(Length2(axis) > 1e-3)
                {
                    gBallOrientation[i] = matrix_3x3(axis,angle) * gBallOrientation[i];
                }
            }
            else  // track an angular acceleration
            {     // somehow, someday

            }
         }

#ifdef GAME_SOUNDS
         if (gBallChan[i])
         {
            if (rolling)
            {
               sound_channel_set_volume(gBallChan[i],1.0f);
               sound_channel_set_position(gBallChan[i],pCurBall->loc.x,pCurBall->loc.y,pCurBall->loc.z);
               sound_channel_play(gBallChan[i]); // In case it got squelched
            }

            // do we need to refill the buffer?
            if (sound_channel_get_samples_remaining(gBallChan[i])<30000) {
               sound_channel_append(gBallChan[i],ROLL_SOUND);
            }
         }
#endif

         pCurBall->ai_timer=0xffff;  // for now, as we hack all this
         
         // check the stuff - look for nearby guys
         if (rolling)
            findGuysInCircle(pCurBall->loc.x,pCurBall->loc.y,BALL_H,DudeKillCBack,NULL);

         vec3f flee_loc;
         vec3f_add_scale(&flee_loc,&pCurBall->loc,&pCurBall->vel,gBallSpd[i]*60);
         findGuysInSphere(pCurBall->loc.x,pCurBall->loc.y,pCurBall->loc.z,BALL_H*3,DudeFleeCBack,NULL);
      }

   FinishKills();
#ifdef GAME_SOUNDS
   real32 cam_pos[4];
   GetCameraLocation(*GlobalCamera,cam_pos);
   sound_listener_set_position(cam_pos[0],cam_pos[1],cam_pos[2]);
#endif
}

void BallsCollide(void)
{
   
}

void BallDraw(void)
{  // draw the ball
    glMatrixMode(GL_MODELVIEW);
    glEnable(GL_LIGHTING);
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_NORMALIZE);
    GLfloat const LightPosition[4] = {1.0f, -1.0f, 1.0f, 0.0f};
    glLightfv(GL_LIGHT0, GL_POSITION, LightPosition);
    float aAmbient[4] = { 0.5f, 0.5f, 0.5f, 1.0f };
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT,aAmbient);
    float aSpecular[4] = { 1.f, 1.f, 1.f, 1.0f };
    float Shininess = 16.0;
    glMaterialfv(GL_FRONT,GL_SPECULAR,aSpecular);
    glMaterialfv(GL_FRONT,GL_SHININESS,&Shininess);
#define GL_LIGHT_MODEL_COLOR_CONTROL_EXT 0x81F8
#define GL_SINGLE_COLOR_EXT 0x81F9
#define GL_SEPARATE_SPECULAR_COLOR_EXT 0x81FA
    glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL_EXT,GL_SEPARATE_SPECULAR_COLOR_EXT);
    glEnable(GL_LIGHT0);
    
    glEnable(GL_COLOR_MATERIAL);
    glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);
    glColor3f(1.0f, 1.0f, 1.0f);

    for (int i=0; i<MAX_BALLS; i++)
    if (BallActive(i))
    {
        BindBallTexture(i);
        glPushMatrix();
        float M[16];
        glTranslatef(0, 0, BALL_H);
        CreateOpenGLTransform(gBallOrientation[i],vector_3((float*)&gBalls[i].loc),M);
        glMultMatrixf(M);
        glScalef(BALL_H, BALL_H, BALL_H);
        glCallList(ballDisplayList);
        glPopMatrix();
      }
   
   glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL_EXT,GL_SINGLE_COLOR_EXT);
   glDisable(GL_LIGHTING);
   glDisable(GL_COLOR_MATERIAL);
   glDisable(GL_NORMALIZE);
}

int lastScore=-1;

// go compute the  - add it to the list - display
void BallScoreGame(void)
{
   char  tmp[255];
   char  name[20][40];
   int   throws[20], best[20];
   float time[20];
   int   count[20];
   int   i, place=-1;

   // sorry, no semaphore

   // this is the dumbest score file reader ever
   //   "time - count - name - throws - best ball"
   // first 10 are "complete games", next 10 are "best kills"
   // should change it to "per second, really"
   FILE *fp = fopen(SCORE_FILE,"r");
   if (fp)
   {
      // skip the two comment lines
      fgets(tmp,255,fp);
      fgets(tmp,255,fp);
      for (i=0; i<20; i++)
         if (fscanf(fp,"%f %d %s %d %d",&time[i],&count[i],name[i],&throws[i],&best[i])!=5)
         {
            time[i]=0; count[i]=0; strcpy(name[i],"RocksMyWorld"); throws[i]=0; best[i]=0;
         }
      fclose(fp);
   }
   else
      for (i=0; i<20; i++)      
      {
         time[i]=0; count[i]=0; strcpy(name[i],"RocksMyWorld"); throws[i]=0; best[i]=0;
      }
   if (gGuyCount==0)
   {
      for (i=0; i<10; i++)
         if ((place==-1)&&((time[i]==0)||(time[i]>cur_game_time)))
         {
            place=i;
            break;
         }
   }
   else
   {
      for (i=10; i<20; i++)
         if ((place==-1)&&((count[i]>gGuyCount)||count[i]==0))
         {
            place=i;
            break;
         }
   }

   if (place!=-1)  // you placed
   {
      int move_lo=place, move_hi=place<10?9:19;

      for (i=move_hi; i>move_lo; i--)
      {
         time[i]=time[i-1]; count[i]=count[i-1];
         strcpy(name[i],name[i-1]); 
         throws[i]=throws[i-1]; best[i]=best[i-1];
      }
      time[i]=cur_game_time; 
      count[i]=gGuyCount;
      // get the user name, strip spaces
      char *p=name[i], *uname = getenv("USER");
      if (uname)
      {
         for (int j=0; j<(int)strlen(uname); j++)
            if (uname[j]!=' ')
               *p++=uname[j];
         *p++='\0';
      }
      else
         strcpy(name[i],"NewPlaya"); 
      throws[i]=gBallThrows; 
      best[i]=gBestKills;

      fp=fopen(SCORE_FILE,"w");
      if (fp)
      {
         fprintf(fp,"# autogenerated irrascible god bowling score file\n");
         fprintf(fp,"# so please do not mess avec\n");
         for (i=0; i<20; i++)
            if (fprintf(fp,"%f %d %s %d %d\n",time[i],count[i],name[i],throws[i],best[i])!=4)
               printf("Write Error record %d\n",i);
         fprintf(fp,"Last game placed %d\n",place);
         fclose(fp);
      }
   }
   lastScore=place;
}

char  s_name[20][40];
int   s_throws[20], s_best[20];
float s_time[20];
int   s_count[20];
int   s_valid=0;

void BallDisplayScores(void)
{
   char  tmp[255];
   int   i, place=-1;

   if (s_valid==0)
   {
      FILE *fp = fopen(SCORE_FILE,"r");
      if (fp)
      {
         // skip the two comment lines
         fgets(tmp,255,fp);
         fgets(tmp,255,fp);
         for (i=0; i<20; i++)
            if (fscanf(fp,"%f %d %s %d %d",&s_time[i],&s_count[i],s_name[i],&s_throws[i],&s_best[i])!=5)
            {
               s_time[i]=0; s_count[i]=0; strcpy(s_name[i],"RocksMyWorld"); s_throws[i]=0; s_best[i]=0;
            }
         fclose(fp);
         s_valid=1;
      }
   }

   AppSetupFontDraw((WindowWidth/2)-220,WindowHeight-35);
   if (s_valid)
   {
      for (i=0; i<20; i++)
      {
         if (i==10)
            glTranslatef(0.0f,-12.0f, 0.0f);
         sprintf(tmp,"%4.2f %6.6d %20.20s %3.3d %4.4d",s_time[i],s_count[i],s_name[i],s_throws[i],s_best[i]);
         if (lastScore==i)
            glColor3f(1,0,0);
         DrawString(*angryFont,tmp);
         if (lastScore==i)
            glColor3f(0.8f,0.8f,0.8f);
         glTranslatef(0.0f,-23.0f, 0.0f);
      }
   }
   else
   {
      sprintf(tmp,"No Score Data found in %s",SCORE_FILE);
      glColor3f(1,0,0);
      DrawString(*angryFont,tmp);
   }
}

void DrawPowerBar(void)
{
#ifdef POWER_BAR
   // hey, how about a power bar, eh?
   glDisable(GL_DEPTH_TEST);
   glDisable(GL_TEXTURE_2D);
   glBegin(GL_QUADS);

   float bar_max=gPowerBarMax;
   float bar_cur=gPowerBarCur;
   float bar_width=(WindowWidth/20);
   float bar_height=(WindowHeight-90);
   float bar_x=WindowWidth-(bar_width*3/2);
   float bar_y=50;

   float bar_st=(bar_cur<0)?0:bar_cur;

   glColor3f(0.1f,0.1f,0.8f);
   glVertex3f(bar_x,bar_y+(bar_height*bar_st),0);
   glVertex3f(bar_x+bar_width,bar_y+(bar_height*bar_st),0);
   glVertex3f(bar_x+bar_width,bar_y+(bar_height*bar_max),0);
   glVertex3f(bar_x,bar_y+(bar_height*bar_max),0);

   // @todo: red bar near 0
   if (bar_cur>0)
   {
      glColor3f(0.1f,0.8f,0.1f);
      glVertex3f(bar_x,bar_y,0);
      glVertex3f(bar_x+bar_width,bar_y,0);
      glVertex3f(bar_x+bar_width,bar_y+(bar_height*bar_cur),0);
      glVertex3f(bar_x,bar_y+(bar_height*bar_cur),0);
   }
   else if (bar_cur<0)
   {
      glColor3f(0.8f,0.1f,0.1f);
      glVertex3f(bar_x,bar_y+(bar_height*bar_cur),0);
      glVertex3f(bar_x+bar_width,bar_y+(bar_height*bar_cur),0);
      glVertex3f(bar_x+bar_width,bar_y,0);
      glVertex3f(bar_x,bar_y,0);
   }

   glEnd();

   glEnable(GL_TEXTURE_2D);
   glEnable(GL_DEPTH_TEST);
#endif
}

void draw_debug_string(char *s, int sx, int sy) {
      AppSetupFontDraw(sx, sy);
      DrawString(*angryFont, s);
      glTranslatef(-sx, -sy, 0);
}
void AngryScore(void)
{
   char buf[80];

   if (gScoreMode)
      BallDisplayScores();
   else
   {
      AppSetupFontDraw(WindowWidth-450,WindowHeight-28);
      s_valid=0;
      
      float dGdF=0;
      {
#define SIZE 16
         static int dCall[SIZE];
         static int oldGuy=-1;
         int dFrame=0, total=0;
         if (oldGuy==-1)
            oldGuy=gGuyCount;
         int deltaG=gGuyCount-oldGuy;
         total-=dCall[dFrame];
         total+=deltaG;
         dCall[dFrame]=deltaG;
         dFrame=(dFrame+1)%SIZE;
         dGdF=(float)total/(float)SIZE;
      }
      sprintf(buf,"%6.6d left, %3.2f, best %d, dGuy/dF: %3.3f",gGuyCount,cur_game_time,gBestKills,dGdF);
      DrawString(*angryFont,buf);

      // undo the font translation
      glTranslatef(-(WindowWidth-450),-(WindowHeight-28), 0);  

      int sx = WindowWidth - 450;
      int sy = WindowHeight - 80;
      int h = 30;

      Sound_Manager *manager = g_sound_manager;
/*
      List debug_strings;
      if (manager) manager->get_debug_strings(&debug_strings);
      char *s;
      Foreach(&debug_strings, s) {
          draw_debug_string(s, sx, sy);
          free(s);
          sy -= h;
      } Endeach;
*/

      DrawPowerBar();
   }
}

// this is a new game
void angryGuysInit(int guyCnt)
{
#if RANDGUYS
    for(int ii = 0;ii < RandGuysCount;++ii) {
        rand_guys &rg = RandGuys[ii];
        rg.mode = animation_mode_create();
        rg.set = animation_texture_set_create_doom_style(rg.name,rg.anim,rg.frames,8);
        animation_mode_set_texture(rg.mode,rg.set);
    }
#endif

    Guy guy_template;
    guysClearGuy(&guy_template);
    Guy *pGuy = &guy_template;
    TYPE(pGuy) = 0;
    pGuy->physics_mode = PM_FLOORED;
    pGuy->ai_timer = floatrand() * 1024;
    pGuy->ai_mode = kaiNone;

    // value_map testing
    MapSetTerrainTexture("data/angry.psd");
    value_map *HF = MapLoad("data/angry.psd",3); assert(HF);
    value_map *Density = MapLoad("data/angry.psd",4);  assert(Density);
    value_map *Positions = MapLoad("data/angry.psd",5); assert(Positions);
    value_map *Heights = MapLoad("data/angry.psd",6); assert(Heights);
    MapSetRange(HF,0,128);
    MapSetHeightField(HF);
//    MapSetTerrainTextureChannels(Density,0,0);
    MapSetRange(Heights,100,200);
    MapAllocateBuildings(Positions,Heights);
    MapAllocateGuyDensity(Density,pGuy,0,MAX_GUYS,true,true);
    MapFree(HF);
    MapFree(Density);
    MapFree(Positions);
    MapFree(Heights);

    // stuff their velocities randomly
    for(int i = 0;i < MAX_GUYS;++i) {
        Guy *pGuy = gGuys+i;
#if RANDGUYS    
        animation_dude_set_mode(pGuy,RandGuys[rand()%RandGuysCount].mode);
#else
        // @todo shouldn't stuff this directly!  have default mode in header
        pGuy->animation_mode_index = 0;
#endif
        pGuy->animation_direction = 0;
        pGuy->animation_timing_offset = rand() % ((4*256) >> 3);
        pGuy->collide_flags = 128;   // bit 7 = flocking
        pGuy->be_collided_with_flags = 129;
        pGuy->num_flock =0;
        float vx = floatrandneg() * GUY_WIDTH;  // @todo stupid consts?!?!
        float vy = floatrandneg() * GUY_HEIGHT;
        setSpeed(pGuy, FOLLOW_SPEED);
        setVelocity(pGuy, vx, vy, 0);
    }
    
    guysFinishInit(guyCnt);
}

void BallNewGame(void)
{
   // close down and score old game
   for (int i=0; i<MAX_BALLS; i++)
      if (BallActive(i))
         BallDeactivate(i);
   // should retire all kills too
   BallScoreGame();

   // now start the new one
   cur_game_time=0;
   setNumGuys(INITIAL_GUYS);
   angryGuysInit(INITIAL_GUYS);
   gBestKills=0;
   gBallThrows=0;
}

void PickupCBack(Guy *g, float d2, void *parm)
{
   if (pickUpIdx<MAX_PICKED)
   {
      TYPE(g)=3;
      g->physics_mode=PM_FLY_THROUGH_BUILDINGS;
      g->loc.z+=24.0;
      g->vel.x=g->vel.y=g->vel.z=0;
      g->collide_flags = 0;
      pickUpList[pickUpIdx++]=g;
   }
}

void BallHandSelect(void)
{
   if (gBallPickedup)
   {
      for (int i=0; i<pickUpIdx; i++)
      {
         Guy *g=pickUpList[i];
         TYPE(g)=0;
         g->physics_mode=PM_GRAVITY;
         g->collide_flags = 128;
         aimGuyAlong(g);
      }
      pickUpIdx=0;
   }
   else
      findGuysInSphere(playerCursorPos.x,playerCursorPos.y,playerCursorPos.z,20,PickupCBack,NULL);
   gBallPickedup=!gBallPickedup;
}

// set things up - load sound samples...
void BallInit(void)
{
   gameGuyHitTerrain = AngryGuyHitTerrain;
   gameGuyAITimer = AngryGuyAITimer;
   guysInit();
   angryGuysInit(INITIAL_GUYS);

   angryFont = LoadFont("data/arial20.font");

   prophet_mode = animation_mode_create();
   prophet_texture_set = animation_texture_set_create_doom_style("sprites/hexen/sprites/icey", 'A', 4, 8, true, 3, 5);
   animation_mode_set_texture(prophet_mode, prophet_texture_set);

   death_mode = animation_create("sprites/doom95/sprites/sarg", 'I', 6, 1, false); // non-looping
   animation_mode_set_speed(death_mode, 3.0);
   post_death_mode = animation_create("sprites/doom95/sprites/sarg", 'N', 1, 1); // non-looping

   // @todo this gib stuff needs to make its way into the sprite_texture
   GibTexture = CreateSpriteTexture(256, 1);
   AddAnimationToSpriteTexture(*GibTexture, "sprites/doom95/sprites/sarg", 'I', 6, 1, 1.0, 1.0, true);
   
   ballDisplayList = glGenLists(1);

   {for(int32 BallIndex = 0;
        BallIndex < MAX_BALLS;
        ++BallIndex)
   {
       int width = BALL_TEXTURE_WIDTH;
       int height = BALL_TEXTURE_HEIGHT;
       void *data = gBallTextures[BallIndex] = (uint32 *)malloc(4 * width * height);
       memset(data, 0x10, 4 * width * height);
       glGenTextures(1, &gBallTextureHandles[BallIndex]);
       glBindTexture(GL_TEXTURE_2D, gBallTextureHandles[BallIndex]);
       assert(gBallTextureHandles);

       glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,     GL_CLAMP);
       glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,     GL_CLAMP);
       glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

       glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

       // @todo: hey, we should subimage correctly update this
       glTexImage2D(GL_TEXTURE_2D, 0,
                    4, width, height, 0,
                    GL_BGRA_EXT, GL_UNSIGNED_BYTE, data);
   }}
   
   glNewList(ballDisplayList, GL_COMPILE);
   GLUquadricObj *BallQuadric = gluNewQuadric();
   gluQuadricTexture(BallQuadric, GL_TRUE);
   gluQuadricNormals(BallQuadric, GLU_SMOOTH);
   gluQuadricDrawStyle(BallQuadric, GLU_FILL);
   assert(glGetError() == GL_NO_ERROR);
   gluSphere(BallQuadric, 1.0f, 12, 12);   
   gluDeleteQuadric(BallQuadric);
   glEndList();
}

void BallLaunch(void)
{
#ifdef POWER_BAR
   switch (gBallLaunching)
   {
   case 0: // go from waiting around to first click (ramp up)
      gBallLaunching++;
      break;
   case 1: // start back down, freeze launch power
      gPowerBarLaunch=gPowerBarCur;
      gBallLaunching++;
      break;
   case 2:
      // do the launch - send a power and an accuracy
      BallCreate();
      gBallLaunching=0;
      gPowerBarMax-=gPowerBarLaunch;
      gPowerBarCur=0;
      break;
   }
#else
   BallCreate();
#endif
}
void infect_guys();
int BallChar(int charcode)
{
   switch (charcode)
   {
      case 'k': gScoreMode=!gScoreMode; return 1;
      case '7': infect_guys();
   }
   if (!gScoreMode)
   {
      switch (charcode)
      {
//         case 'f': BallCreate();     return 1;
         case 'b': BallLaunch();     return 1;
         case 'n': BallNewGame();    return 1;
         case 'l': BallHandSelect(); return 1;
         case 'p': gBallPause=!gBallPause; return 1;
      }
   }
   return 0;
}

//////////
// misc dumb stuff i want somewhere else

void rand_vec3f(vec3f *v)
{
   v->x=floatrand();
   v->y=floatrand();
   v->z=floatrand();
}

void randneg_vec3f(vec3f *v)
{
   v->x=floatrandneg();
   v->y=floatrandneg();
   v->z=floatrandneg();
}

void InfectCallback(Guy *guy, float d2, void *parm) {
    TYPE(guy) = 3;
    guy->debug_color = 1;
    guy->collide_flags |= 1;
}

void infect_guys() {
    float x = playerCursorPos.x;
    float y = playerCursorPos.y;
    float z = playerCursorPos.z;
    findGuysInSphere(x, y, z, 30, InfectCallback, NULL);
}

/////////////////////
// hookup to app.cpp

void AngryRender(void)
{
   BallDraw();
   AngryScore();
}

void AngryTick(float time, float dt)
{
   BallTick(dt);
   static bool first = TRUE;
   if (first) {
      memcpy(hf_old, height_field, sizeof(hf_old));
      first = FALSE;
   }
   for (int j=0; j < HF_Y; ++j) {
      for (int i = 0; i < HF_X; ++i) {
          height_field[j][i] = hf_old[j][i] + 6*sin(i+time) + 6*cos(j+time*1.2);
      }
   }
}

int AngryChar(int charcode)
{
   return BallChar(charcode);
}

void BioTerrorCallback(Guy *collider, Guy *collidee) {
    collidee->collide_flags |= 1;
    collider->debug_color = 1;
}

void AngryInit(void)
{
   BallInit();

   // guys flock twice per second, looking around them at most 8.0 world units,
   // using bit #7 of the collision flags
   // if you want multiple flocking groups, specify the flocking behaviors
   // in the collision flags (e.g. two groups, one sets #6, one sets #7, and
   // pass in #6 + #7 here, i.e. 0x80+0x40)
   initFlocking(2.0, 8.0, 0x80);

   // bio terror tests happen once every three seconds,
   // look around them at most 2.0 world units, and use
   // bit #0 of the collision flags for bioterror collisions
   // (all guys are collidees, only infected guys are colliders
   // in bit #0)
   createCollisionManager(0.33, 2, 0x01, BioTerrorCallback);
   // bio terror effect is only visible by turning on DEBUG_COLOR
   // in guys.cpp or by using a debug build.
}

