//const int PACKED_TEXTURE_WIDTH = 1024;   // One big 1024x1024 texture.
const int PACKED_TEXTURE_WIDTH = 2048;   // One big 1024x1024 texture.

const int MAX_ANIMATION_MODES = 256;
const int MAX_ANIMATION_TEXTURE_SETS = 64;
const int MAX_ANIMATION_FRAMES = 8;
const int MAX_ANIMATION_VIEW_ANGLES = 8;

struct Animation_Texture_Set;

struct sprite_grind_state;
struct sprite_texture;
struct Guy;

struct Animation_Mode {
    void init();

    Animation_Texture_Set *texture_set;
    float frames_per_second;
    int my_index;

    int frame_index_times_256;
    int mode_is_wrapping_animation;
    Animation_Mode *mode_to_transition_into;
};

struct Animation_Texture_Set {
    void init();

    int sprite_texture_index;
};

struct Animation_Manager {
    void init();
    void update();

    int packed_sprite_texture_handle;
    int texture_width;
    bool packed_sprite_texture_is_dirty;

    Animation_Mode *get_next_animation_mode();
    Animation_Texture_Set *load_texture_set_wad_style(char *prefix, char letter, int nframes, int nviews, float x_scale, float y_scale, bool loop);
    void ensure_texture_is_ready();

    friend void drawCenteredWithScale(Guy *, int, float, float);

    int num_animation_modes;
    int num_texture_sets;
    Animation_Mode animation_modes[MAX_ANIMATION_MODES];
    Animation_Texture_Set texture_sets[MAX_ANIMATION_TEXTURE_SETS];

//  protected:
    sprite_grind_state *grind_state;
    sprite_texture *my_sprite_texture;
};
