struct Guy;
struct Animation_Manager;
struct Animation_Mode;
struct Animation_Texture_Set;

Animation_Mode *animation_create(
                      char *prefix, char letter,
                      int nframes, int nviews,
                      bool loop=true,
                      float x_scale=1.0, float y_scale=0.0);

// There is some maximum number of animation modes that you can define.
// Once you reach this number, animation_mode_create will begin
// returning NULL.  As of this writing the current number is 256, and
// one of those is already used when you initialize the animation
// system (it's the default animation guys get when you don't specify).
Animation_Mode *animation_mode_create();

void animation_mode_set_texture(Animation_Mode *mode, 
                                Animation_Texture_Set *set);
void animation_mode_set_speed(Animation_Mode *mode, float frames_per_second);


// Use this to say which animation mode a particular dude should be in.
void animation_dude_set_mode(Guy *guy, Animation_Mode *mode);

// Use this to put a guy in an animation mode oneshot; the return value
// is the time you must AI timer him to keep him from looping.
int animation_dude_set_mode_oneshot(Guy *guy, Animation_Mode *mode);

Animation_Mode *animation_dude_get_mode(Guy *guy);

Animation_Texture_Set *animation_texture_set_create_doom_style(
                      char *prefix, char letter,
                      int nframes, int nviews,
                      bool loop=true,
                      float x_scale=1.0, float y_scale=0.0);

// Returns the OpenGL texture id of the spec'd thing.
int	animation_get_texture_id(Animation_Texture_Set* texset, int index);
