#if !defined(BMP_H)
/* ========================================================================
   $RCSfile: bmp.h,v $
   $Date: 2002/03/11 13:28:19 $
   $Revision: 1.4 $
   $Creator: Casey Muratori $
   $Notice: $
   ======================================================================== */

#if !defined(GLOBALS_H)
#include "globals.h"
#endif

/*
  These are quick routines for loading and saving bitmaps.
  They suck ass, so they basically only work with BMP files
  that are pretty standard - don't try anything fancy.
  If you're loading a palettized bitmap, you can give it
  a transparency index and it will assume that those pixels
  are alpha=0.

  All pixel data is 32-bit BGRA.  You don't get any options.
  Much like the hot dog stand near GPG, "regular or sausage
  is your only choice", only in this case it's limited
  to the sausage.
 */

struct bmp
{
    int32 Width;
    int32 Height;
    int32 Stride;

    uint32 *Pixels;
};
bmp *ReadBMP(char const *FileName, int32 TransparentIndex = 0 );
// woohoo, the C stdlib rocks with FILE not necessarily typedef-able
bmp *ReadBMP_FILE( void *stdio_FILE_pointer, int32 TransparentIndex, char const *FileNameLog );
void FreeBMP(bmp *BMP);

void WriteBMP(bmp &BMP, char const *FileName);

#define BMP_H
#endif
