#ifndef INC_BUILDINGS_H

extern void buildingCreate(float x0, float y0, float x1, float y1, float h);
extern void buildingCreate(float x0, float y0, float x1, float y1, float h, float r, float g, float b);
extern bool inBuilding(float x, float y);
void drawBuildings(void);
void buildingsInit(void);


#define MAX_BUILDINGS      2048

struct Building
{
   float x0,y0,x1,y1;
   float h;
   float r,g,b;
};

extern Building building[];
extern int num_buildings;

#define BUILDING_X  64
#define BUILDING_Y  64

#define BUILDING_SCALE_X (WORLD_X_POWER_OF_2 / BUILDING_X)
#define BUILDING_SCALE_Y (WORLD_Y_POWER_OF_2 / BUILDING_Y)

extern uint8 building_blocked[BUILDING_X*(BUILDING_Y+2)/8 + 2];

#define BUILDING_NUMBER(x,y)   ((y)*BUILDING_X + (x))
#define BUILDING_INDEX(x,y)    ((BUILDING_NUMBER(x,y) >> 3) + (BUILDING_X >> 3) + 1)
#define BUILDING_BIT(x,y)      (1 << (BUILDING_NUMBER(x,y) & 7))

#define BUILDING_TEST(x,y)          (building_blocked[BUILDING_INDEX(x,y)] & BUILDING_BIT(x,y))
#define BUILDING_SET(x,y)           (building_blocked[BUILDING_INDEX(x,y)] |= BUILDING_BIT(x,y))

/////////////////////////////////////////////////////////////////////////////////////////////
// performance hackery
static double BUILDINGsekrit_temp;
static double BUILDINGsekrit_temp2;
#define FLOAT2INT_BUILDING_X(d) ((BUILDINGsekrit_temp = (((d)-BUILDING_SCALE_X/2)+BUILDING_SCALE_X*6755399441055744.0)), *((int *)(&BUILDINGsekrit_temp)))
#define FLOAT2INT_BUILDING_Y(d) ((BUILDINGsekrit_temp2 = (((d)-BUILDING_SCALE_Y/2)+BUILDING_SCALE_Y*6755399441055744.0)), *((int *)(&BUILDINGsekrit_temp2)))

#define INC_BUILDINGS_H
#endif
