/*
  Indy Game Jam

*/

#include "globals.h"

#include "sound/sound_public.h"
#include "animation.h"
#include "animation_public.h"
#include "guys.h"

Sound_Manager *g_sound_manager;
Animation_Manager *g_animation_manager;

extern void collision_init(void);  // Hide this from user.

void EngineInit( void )
{
    GetTime();      // throw away 0.0

    g_animation_manager = new Animation_Manager();
    g_animation_manager->init();

    collision_init();
}

void EngineSoundInit() {
    if (g_sound_manager) return;

    // Initialize the sound system.

    g_sound_manager = sound_init();
}

void EngineShutdown( void )
{
    if (g_sound_manager) sound_shutdown(g_sound_manager);
}

void EngineUpdate() {
    g_animation_manager->update();
}
