/*
  Indy Game Jam

*/
#if !defined(GLOBALS_H)

#include "vec3f.h"   // @todo inline this?

#pragma warning(disable : 4244)
#pragma warning(disable : 4305)

/********************** types *********************************************/

// if you don't like to type unsigned
typedef int unsigned uint;
typedef char unsigned uchar;

// if you actually want to know what you've got
typedef unsigned char  uint8;
typedef unsigned short uint16;
typedef unsigned int   uint32;
typedef   signed char   int8;
typedef   signed short  int16;
typedef   signed int    int32;
typedef   __int64       int64;

typedef float real32;
typedef double real64;
real32 const Pi32 = 3.14159265358979323846f;

#define PROCESSOR_BIG_ENDIAN 0

/**************** general engine stuff ********************/
void EngineInit( void );
void EngineSoundInit( void );
void EngineUpdate( void );
void EngineShutdown( void );

extern int WindowWidth;
extern int WindowHeight;

// camera
struct camera;
extern camera *GlobalCamera;

struct Sound_Manager;
struct Animation_Manager;
struct Collision_Manager;

extern Sound_Manager *g_sound_manager;
extern Animation_Manager *g_animation_manager;

/****************** utility functions *************************/


double GetTime( void );
float GenerateUnitRandomReal( void );

void DrawTimingBars( void );  // default framerate

struct timing_bar;
timing_bar *CreateTimingBar( char *Label, int y_idx ); // there are 20 (idx=[0,19]) slots
void MoveTimingBar( timing_bar *Bar, int new_y_idx );
void DrawTimingBar( timing_bar *Bar, float NewValue );

inline float sqr( float v ) { return v * v; }


#define GL_CLAMP_TO_EDGE 0x812F

// Mersenne Twister random number generation in mt.cpp
void init_genrand(unsigned long s);
unsigned long genrand_int32(void);
long genrand_int31(void);
double genrand_real1(void);// [0,1]
double genrand_real2(void);// [0,1)
double genrand_real3(void);// (0,1)
double genrand_res53(void);// [0,1) full 53 bit precision

extern float floatrand(void);
extern float floatrandneg(void);
extern void  rand_vec3f(vec3f *v);
extern void  randneg_vec3f(vec3f *v);

// other rand stuff...
// call once at program start
extern void SeedRand (int r);
// return random number in range [low, high)
extern int random (int low, int high);
// return random float in range [0.0, 1.0]
extern float frandom (void);


extern double g_server_time;


#define GLOBALS_H
#endif
