#ifndef INC_HF_H


extern bool pickHF(vec3f *res, int x, int y);
// find the terrain height...
extern float ground(float x, float y);
extern float ground_slope(float x, float y, float *dx, float *dy);

void drawHF(void);
void hfInit(void);
void texInit(void);

// Make an OpenGL tex id from the given data.
int texMake32(int w, int h, uint8 *data, uint WrapMode);

// change HF_SCALE to increase or decrease the size of the world, sorry it's power of two

#define HF_SCALE  64     // MUST BE POWER OF TWO
#define HF_Y  32          
#define HF_X  32          // POWER OF TWO RECOMMENDED

extern float height_field[HF_Y][HF_X];

// world coordinates goes from [0,WORLD_X], [0,WORLD_Y]
// @todo or sometimes [0,WORLD_X), [0,WORLD_Y), argh!
#define WORLD_X ((HF_X-1)*HF_SCALE)
#define WORLD_Y ((HF_Y-1)*HF_SCALE)
    
#define WORLD_X_POWER_OF_2   (HF_X*HF_SCALE)
#define WORLD_Y_POWER_OF_2   (HF_Y*HF_SCALE)

/////////////////////////////////////////////////////////////////////////////////////////////
// performance hackery
static double HFsekrit_temp;
static double HFsekrit_temp2;
#define FLOAT2INT_BIN(d) ((HFsekrit_temp = ((d)+BIN_SIZE*6755399441055744.0)), *((int *)(&HFsekrit_temp)))
#define FLOAT2INT2_BIN(d) ((HFsekrit_temp2 = ((d)+BIN_SIZE*6755399441055744.0)), *((int *)(&HFsekrit_temp2)))
#define FLOAT2FIX_HF(d) ((HFsekrit_temp = ((d)+HF_SCALE*6755399441055744.0/65536)), *((int *)(&HFsekrit_temp)))
#define FLOAT2FIX2_HF(d) ((HFsekrit_temp2 = ((d)+HF_SCALE*6755399441055744.0/65536)), *((int *)(&HFsekrit_temp2)))

#define INC_HF_H
#endif
