#if !defined(IMAGE_OPERATIONS_H)
/* ========================================================================
   $RCSfile: image_operations.h,v $
   $Date: 2001/12/16 00:04:37 $
   $Revision: 1.2 $
   $Creator: Casey Muratori $
   $Notice: $
   ======================================================================== */

#if !defined(GLOBALS_H)
#include "globals.h"
#endif

enum pixel_filter_type
{
    CubicPixelFilter,
    LinearPixelFilter,
    BoxPixelFilter,

    OnePastLastPixelFilterType
};

void ScaleImage(pixel_filter_type FilterType,
                int32 SourceWidth, int32 SourceHeight,
                int32 SourceStride, uint8 const *SourcePixels,
                int32 DestWidth, int32 DestHeight,
                int32 DestStride, uint8 *DestPixels);

struct pixel_layout
{
    int32 BytesPerPixel;

    // These are for R, G, B, A respectively
    int32 ShiftForComponent[4];
    int32 BitsForComponent[4];
};
void ConvertPixelFormat(int32 Width, int32 Height,
                        pixel_layout const &SourceLayout,
                        int32 SourceStride, void const *SourceBits,
                        pixel_layout const &DestLayout,
                        int32 DestStride, void *DestBits);

extern pixel_layout const RGB555PixelFormat;
extern pixel_layout const RGB565PixelFormat;
extern pixel_layout const RGBA5551PixelFormat;
extern pixel_layout const RGBA4444PixelFormat;
extern pixel_layout const RGB888PixelFormat;
extern pixel_layout const RGBA8888PixelFormat;
extern pixel_layout const BGR555PixelFormat;
extern pixel_layout const BGR565PixelFormat;
extern pixel_layout const BGRA5551PixelFormat;
extern pixel_layout const BGRA4444PixelFormat;
extern pixel_layout const BGR888PixelFormat;
extern pixel_layout const BGRA8888PixelFormat;

#define IMAGE_OPERATIONS_H
#endif
