/* ========================================================================
   $RCSfile: memory_arena.cpp,v $
   $Date: 2001/12/15 02:21:28 $
   $Revision: 1.1 $
   $Creator: Casey Muratori $
   $Notice: $
   ======================================================================== */

#include <stdlib.h>

#if !defined(MEMORY_ARENA_H)
#include "memory_arena.h"
#endif

struct memory_arena
{
    memory_arena *Next;
};

memory_arena * 
NewMemoryArena(void)
{
    memory_arena *NewArena = (memory_arena *)
        malloc(sizeof(memory_arena));
    if(NewArena)
    {
        NewArena->Next = 0;
    }

    return(NewArena);
}

void  
ClearArena(memory_arena *Arena)
{
    FreeMemoryArena(Arena->Next);
    Arena->Next = 0;
}

void  
FreeMemoryArena(memory_arena *Arena)
{
    memory_arena *ArenaIterator = Arena;
    while(ArenaIterator)
    {
        memory_arena *DeleteArena = ArenaIterator;
        ArenaIterator = ArenaIterator->Next;

        free(DeleteArena);
    }
}

void * 
MemoryArenaPush(memory_arena &Arena, int32 Size)
{
    void *Result = 0;
    
    memory_arena *NewChunk = (memory_arena *)
        malloc(sizeof(*NewChunk) + Size);
    if(NewChunk)
    {
        NewChunk->Next = Arena.Next;
        Arena.Next = NewChunk;
        Result = (uint8 *)NewChunk + sizeof(memory_arena);
    }

    return(Result);
}
