
#ifndef NET_H
#define NET_H

#include "globals.h"

extern int g_LocalPlayer;

// Messages
//======================================================

enum Msgs 
{
	msgLogin = 1,
	msgLoginConfirm,
	msgClientInput,
	msgAllPlayerInput,
};


enum Input_t
{
	INPUT_BUTTON_DOWN,
	INPUT_BUTTON_UP,
	INPUT_BUTTON_DBLCLICK,
	INPUT_CHAR,
	INPUT_SERVER_TIME,
	INPUT_SERVER_RESET,
	INPUT_CLIENT_EOM,

	// App-defined messages
	INPUT_PLAYER_MOVE,
	INPUT_PLAYER_FACE,
//	INPUT_PLAYER_VEL,
	INPUT_PING,
	INPUT_SHOOT,
	INPUT_GAME_START,
	INPUT_GUY_START,	// marks the start of INPUT_GUY_STATE packets.
	INPUT_GUY_STATE,
};


#define MAX_PLAYERS 2


void AddClientInput( Input_t input, int x, int y, int z = 0 );
void AddClientInput( Input_t input, const vec3f & v );
void TransmitClientInput();
void NetInit( char const* pCommandLine );
void NetFrame();
void NetShutdown();
bool IsPlayerConnected( int player );

int GetNumClientsConnected();

typedef void (*PostNetworkMessages_t)( );
typedef void (*ProcessNetworkMessage_t)( int player, Input_t input, int x, int y, int z );

extern PostNetworkMessages_t g_PostNetworkMessages;
extern ProcessNetworkMessage_t g_ProcessNetworkMessages;

extern int client;
extern int server;
extern int clientIsLoggedIn;
extern int clientIsConnected;

#endif

