// don't include this, this means you

#define PREFETCH         NO_PREFETCH
//#define PREFETCH_TWO_BLOCKS

#define NO_PREFETCH      0
#define FORCED_PREFETCH  1
#define ATHLON_PREFETCH  2
#define INTEL_PREFETCH   3
#define INTEL_PREFETCH2  4

static void athlon_prefetch(void *p)
{
   __asm {
      mov eax,p
      _emit 0x0F
      _emit 0x0D
      _emit 0x48
      _emit 0x00
#ifdef PREFETCH_TWO_BLOCKS
      _emit 0x0F
      _emit 0x0D
      _emit 0x48
      _emit 0x20
#endif
   }
}

static void intel_prefetch(void *p)
{
	__asm {
      mov eax,p
      _emit 0x67
      _emit 0x0f
      _emit 0x18
      _emit 0x48
      _emit 0x0
#ifdef PREFETCH_TWO_BLOCKS
      _emit 0x67
      _emit 0x0f
      _emit 0x18
      _emit 0x48
      _emit 0x20
#endif
   }
}

static void intel_prefetch2(void *p)
{
	__asm {
      mov eax,p
      _emit 0x67
      _emit 0x0f
      _emit 0x18
      _emit 0x40
      _emit 0x00
#ifdef PREFETCH_TWO_BLOCKS
      _emit 0x67
      _emit 0x0f
      _emit 0x18
      _emit 0x40
      _emit 0x20
#endif
   }
}

static void forced_prefetch(void *p)
{
	__asm {
      push ebx
      mov eax,p
      mov ebx,[eax+0]
#ifdef PREFETCH_TWO_BLOCKS
      mov ebx,[eax+32]
#endif
      pop ebx
   }
}

#if PREFETCH == ATHLON_PREFETCH
  #define do_prefetch(g)     athlon_prefetch(g)
#elif PREFETCH == INTEL_PREFETCH
  #define do_prefetch(g)     intel_prefetch(g)
#elif PREFETCH == INTEL_PREFETCH2
  #define do_prefetch(g)     intel_prefetch2(g)
#elif PREFETCH == FORCED_PREFETCH
  #define do_prefetch(g)     forced_prefetch(g)
#else
  #define do_prefetch(g) 
#endif
