#include "sound_internal.h"
#include "file.h"

typedef unsigned char uchar;

// fread_<X>b()
//
//  reads <X> bytes from f.
//
//  f:   file to read <X> bytes from.
//  ok:  if not NULL, fread_<X>b sets the success value.
//       If *ok is allready false, it will LEAVE this value at
//       false, so its initialization should be == true before 
//       passing it into this function.

unsigned char fread_1b(FILE *f, bool *ok){
    int r=99;

    if(f==NULL){
        r = EOF;
    }else{
        r = fgetc(f);
    }
  
    if(ok!=NULL && *ok!=false){
        if(r==EOF)   *ok = false;
        else         *ok = true;
    }

    return ((unsigned char)r);
}

int fread_2b(FILE *f, bool *ok){
    short  s_res=99;
    int    err,res;
    short  r1,r2;

    if(f==NULL){
        err = EOF;
    }else{

        r1 = (short) fgetc(f);
        err =        fgetc(f);

        r2 = (short) err;

        s_res =                r2;
        s_res = (s_res << 8) + r1;
    }

    if(ok!=NULL && *ok!=false){
        if(err==EOF) *ok = false;
        else         *ok = true;
    }

    res = s_res;
    return(res);
}

long fread_4b(FILE *f, bool *ok){
    long  res=99;
    int   r1,r2,r3,r4;

    if(f==NULL){
        r4 = EOF;
    }else{
        r1 = fgetc(f);
        r2 = fgetc(f);
        r3 = fgetc(f);
        r4 = fgetc(f);

        res =              (unsigned char) r4;
        res = (res << 8) | (unsigned char) r3;
        res = (res << 8) | (unsigned char) r2;
        res = (res << 8) | (unsigned char) r1;
    }

    if(ok!=NULL && *ok!=false){
        if(r4==EOF) *ok = false;
        else        *ok = true;
    }

    return(res);
}




int fwrite_1b(FILE *f, unsigned int val) {
    int result;
    result = fputc(val, f);

    if (result == EOF) return 0;
    return 1;
}

int fwrite_2b(FILE *f, unsigned int val) {
    uchar b2 = (val >> 8) & 0xff;
    uchar b1 = (val >> 0) & 0xff;

    int result;
    result = fputc(b1, f);
    result = fputc(b2, f);

    if (result == EOF) return 0;
    return 1;
}

int fwrite_4b(FILE *f, unsigned int val) {
    uchar b4 = (val >> 24) & 0xff;
    uchar b3 = (val >> 16) & 0xff;
    uchar b2 = (val >>  8) & 0xff;
    uchar b1 = (val >>  0) & 0xff;

    int result;
    result = fputc(b1, f);
    result = fputc(b2, f);
    result = fputc(b3, f);
    result = fputc(b4, f);

    if (result == EOF) return 0;
    return 1;
}


