#include "sound_internal.h"

#include "mprintf.h"

/* (not thread safe):
// SPECIAL NOTE: vsnprintf is specified slightly 
// differently on different systems.  This is why
// the check for success is so explicit....
*/

char *mprintf(char *fmt, ...) {
    char *res = NULL;
    int size = MPRINTF_INITIAL_GUESS;

    while (1) {
        res = (char *) malloc(size);
		if (!res) return NULL;

		va_list ap;
		va_start(ap, fmt);

		int len = vsnprintf(res, size, fmt, ap);
		va_end(ap);

		if ((len >= 0) && (size >= len + 1)) {
			size = len;
			break;
		}

		free(res);
		size *= 2;							
    }

    return res;
}

