#if !defined(SYSTEM_H)

/*----------------------------------------------------------------------------

  Define these pointers globally in your game and system.cpp calls them.
  - use 0 for functions you don't care about

*/

struct system_hooks
{
    void (*GameInit)(void);
    void (*GameRender)(void);
    void (*GameTick)(float time, float dt);
    int  (*GameChar)(int charcode);
};

// define me, please!
extern system_hooks SystemHooks;                    


struct input_info {
	int	mouse_x;
	int	mouse_y;
	int	mouse_buttons;

	// some keys.
};
extern input_info*	input;


enum camera_mode {
    DEFAULT_CAMERA_MODE = 0,
    SEAN_SLEW_MODE = 1,
    MOUSE_ORBIT_MODE = 2,
    FOLLOW_ORBIT_MODE = 3,
	FIRST_PERSON_MODE = 4,
    MAX_CAMERA_MODE
};
void AppCameraInit( camera_mode mode, bool InitPosOff = true);



#define SYSTEM_H
#endif
